#define OPTIMIZE_ROM_CALLS
#define RETURN_VALUE
#define MIN_AMS 101
#define leave(str) {ST_helpMsg(str); push_quantum(NOTHING_TAG); return;}
#define IS_LESS(v1, v2)  (v1 < v2)
#define SWAP(r,s)  do{int t=r; r=s; s=t; } while(0)

#include <tigcclib.h>
typedef unsigned long long VLI;	//very long integer
void siftDown(int *a, int start, int count);

//Check if the ESI pointer is an integer
short is_positive_integer (ESI ptr)
{
  return (*ptr == POSINT_TAG);
}

void heap_sort(int *a, int count)
{
    int start, end;
 
    /* heapify */
    for (start = (count-2)/2; start >=0; start--)
    {
        siftDown(a, start, count);
    }
 
    for (end=count-1; end > 0; end--)
    {
        SWAP(a[end],a[0]);
        siftDown(a, 0, end);
    }
}
 
void siftDown(int *a, int start, int end)
{
    int root = start;
 
    while ( root*2+1 < end ) {
        int child = 2*root + 1;
        if ((child + 1 < end) && IS_LESS(a[child],a[child+1])) {
            child += 1;
        }
        if (IS_LESS(a[root], a[child])) {
            SWAP( a[child], a[root] );
            root = child;
        }
        else
            return;
    }
}

void _main(void)
{
	ESI argptr = top_estack;
	
	//Yhe first argument of the TIOS function is the length of the list
	VLI dimension = GetLongLongArg(argptr); 
	VLI i = 0;
	
	//The dynamic array
	int* array = (int*) malloc(dimension * sizeof(int));
	
	//If the second argument is a list
	if(*argptr == LIST_TAG) 
	{
		//Check if all elements of the list are integers
		//Argptr must be decremented by one to point to first element of the list
		if(!all_tail(is_positive_integer, --argptr))	
		{
			leave("List elements must be integers >= 0.");
		}
		else
			while(i<dimension && *argptr != END_TAG) array[i++]=GetLongLongArg(argptr);
	}
	
	heap_sort(array, dimension);
	
	push_END_TAG();
	for(i=dimension; i>0; i--) push_longlongint(array[i-1]);
	push_LIST_TAG();
}